/*
 * sm.c
 * shared memory
 *
 * 09.12.2004 
 */
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
 
   key_t mkey;
   int size;
   int mid; 
   pid_t pid1, pid2;
   char *datap;
   
   
   /*create a mkey from filename and X*/
   mkey=ftok(argv[0],'X');
   if(-1==mkey)
   {
       perror("ftok"); exit(1);
   }  
   
   if((pid1=fork())<0) //2 Processes
   {
       perror("fork1");
       exit(1);
   }
      
   if(pid1)  
   {
       if((pid2=fork())<0) //child 3 Processes
       {
           perror("fork2"); 
           exit(5);
       }
       
   }
   else //3 different processes without a shared memory here
   { 
       mid=shmget(mkey,20,0666);   /*open shared memory*/
   }
   
   if(pid2==0)
   {
       mid=shmget(mkey,20,0666);   /*open shared memory*/
   }
   else
   {
       mid=shmget(mkey,20,IPC_CREAT|0666);/*create shared memory*/
   }
  
   
   if(-1==mid)
   { 
       perror("shmget"); 
       exit(2);
   }

   /*attached memory is inherited with fork() to the new process*/
   datap=shmat(mid,0,0); //attach memory
   
   if(((char*)-1)==datap)
   {
     perror("shmat");exit(3);  
   }
   /* all processes have shared memory now*/
   if(pid1==0) /*child 1 sets values*/
   {
     datap[10]=0;
     datap[12]=0;
   }
   
   do
   {   //child 1
       if(pid1==0)
       {
         /* no synchronisation here */  
         printf("%d %d\n",getpid(),(unsigned char)datap[10]); /*printing value*/
         usleep(100);  
       }
       else 
           if(pid2!=0 && pid1!=0) //parent
           {  
              getchar(); /*waiting for user interrupt*/
              datap[12]=11; /*exit signal*/
              
          }
           else //child 2
           {
              datap[10]++; /*increments a counter*/
              usleep(230);
           }  
   }while(datap[12]!=11);
   
   shmdt(datap); /*detach*/
   shmctl(mid,IPC_RMID,NULL); /*mark for deletion*/
   printf("exit %d\n",getpid());
   return 0;
}
